#!/bin/bash
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is ZINC.
#
# The Initial Developer of the Original Code is Zest Technology Group Ltd.
#
# Portions created by the Initial Developer are Copyright (C) 2004
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

GCC_BINARY_PATH=""

APP_NAME=zinc
TMP_DIR=build.tmp
XPT_LINK="/cygdrive/e/users/cmiss/zinc/zinc/cygwin-wrapper /cygdrive/e/users/cmiss/firefox-1.5-src/mozilla/dist/bin/xpt_link"

rm install/$APP_NAME.xpi
rm -rf $TMP_DIR

BIN_DIR=$TMP_DIR
WIN32=@WIN32@

# create xpi directory layout
mkdir $TMP_DIR
mkdir $BIN_DIR/chrome
mkdir $BIN_DIR/components
mkdir $BIN_DIR/dependent_components
# mkdir $BIN_DIR/defaults
# mkdir $BIN_DIR/defaults/preferences
mkdir $BIN_DIR/plugins

# populate the xpi directory layout
# cp defaults/* $TMP_DIR/defaults
# cp defaults/preferences/* $TMP_DIR/defaults/preferences
$XPT_LINK $BIN_DIR/components/$APP_NAME.xpt components/$APP_NAME/base/public/*.xpt
if test -a "components/$APP_NAME/build/src/libzinc.so"; then
  cp components/$APP_NAME/build/src/libzinc.so $BIN_DIR/components
fi
if test -a "components/$APP_NAME/build/src/zinc.dll"; then
  cp components/$APP_NAME/build/src/zincPreparer/zincPreparer.dll $BIN_DIR/components
#  cp components/mozCmgui/build/src/mozCmguiPreparer/mozCmguiPreparer.dll $BIN_DIR/components
  cp components/$APP_NAME/build/src/zinc.dll $BIN_DIR/dependent_components

  cp /cygdrive/e/Users/cmiss/cmgui/lib/i386-win32/cmgui-debug/libcmgui_general.dll $BIN_DIR
  cp /cygdrive/e/Users/cmiss/cmgui/lib/i386-win32/cmgui-debug/libcmgui_finite_element.dll $BIN_DIR
  cp /cygdrive/e/Users/cmiss/cmgui/lib/i386-win32/cmgui-debug/libcmgui.dll $BIN_DIR
fi

# source file for js XPCOM components needs to be copied into the comonents dir
cp components/$APP_NAME/base/src/*.js $BIN_DIR/components

# generate the jar file...
JARCONTENTS=`find content locale skin -path '*.svn*' -prune -o -type f -print | grep -v \~`

zip -r $BIN_DIR/chrome/$APP_NAME.jar $JARCONTENTS
# can nore remove the components/*.js files

cp install/install.rdf $TMP_DIR

if test ! "$GCC_BINARY_PATH" = ""; then
  # If we are on Win32, also make all .exes run in Win32 subsystem...
  if test "x$WIN32" = "xyes"; then
    gcc make_pe_noconsole.c -o make_pe_noconsole.exe
    for file in `find $BIN_DIR/components/gcc -name "*.exe"`; do
	./make_pe_noconsole.exe $file
    done
  fi
fi

cp ../mergePlugin/zincIPlugin.xpt $BIN_DIR/components
if [ -f merge_plugins/npgeneral.dll ]; then
    #cp plugins/npzincPlugin.dll $BIN_DIR/plugins/
    cp ../mergePlugin/npgeneral.dll $BIN_DIR/plugins
else
    cp plugins/libzincPlugin.so $BIN_DIR/plugins
fi


# generate the XPI file
cd $TMP_DIR
zip -r ../install/$APP_NAME.xpi `find . -path './*CVS*' -prune -o -type f -print | grep -v \~`
cd ..

rm -rf $TMP_DIR
