/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM DiscreteGaussianFilter.idl
 */

#ifndef __gen_DiscreteGaussianFilter_h__
#define __gen_DiscreteGaussianFilter_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIDOMWindow; /* forward declaration */

class CmguiICommandData; /* forward declaration */

class nsIRunnable; /* forward declaration */


/* starting interface:    cmguiIDiscreteGaussianFilter */
#define CMGUIIDISCRETEGAUSSIANFILTER_IID_STR "6599d662-c07a-11db-9b74-1bcc55d89593"

#define CMGUIIDISCRETEGAUSSIANFILTER_IID \
  {0x6599d662, 0xc07a, 0x11db, \
    { 0x9b, 0x74, 0x1b, 0xcc, 0x55, 0xd8, 0x95, 0x93 }}

class NS_NO_VTABLE cmguiIDiscreteGaussianFilter : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(CMGUIIDISCRETEGAUSSIANFILTER_IID)

  /**
   * Initialize the discrete gaussian filter.  The discrete gaussian filter is
   * not valid until this method is called
   *
   * @param commandData CmguiICommandData.  To execute the filter the XPCOM object
   *              must have access to the commandData object.  commandData can not be null.
   * @param inputField string. Name of field to use as input filter, field must have been created before initialising object.
   * @param outputField string. Name of field to use as output filter.  Does not have to have been created.  If it already 
   *              exists the field will be updated with the selected options
   * @param callback nsIRunnable. Function to execute after filter has been applied and the output field has been created.
   */
  /* void init (in nsIDOMWindow parent, in CmguiICommandData commandData, in string inputField, in string outputField, in nsIRunnable callback); */
  NS_IMETHOD Init(nsIDOMWindow *parent, CmguiICommandData *commandData, const char *inputField, const char *outputField, nsIRunnable *callback) = 0;

  /* void apply_filter (); */
  NS_IMETHOD Apply_filter(void) = 0;

  /**
   * Use the discrete gaussian filter dialog to select filter options and apply filter.  
   * The dialog is displayed modally.
   *
   * @param parent nsIDOMWindow.  To open a dialog the component must have the parent window from which the dialog will 
   * be opened
   *
   */
  /* void open_dialog (); */
  NS_IMETHOD Open_dialog(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_CMGUIIDISCRETEGAUSSIANFILTER \
  NS_IMETHOD Init(nsIDOMWindow *parent, CmguiICommandData *commandData, const char *inputField, const char *outputField, nsIRunnable *callback); \
  NS_IMETHOD Apply_filter(void); \
  NS_IMETHOD Open_dialog(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_CMGUIIDISCRETEGAUSSIANFILTER(_to) \
  NS_IMETHOD Init(nsIDOMWindow *parent, CmguiICommandData *commandData, const char *inputField, const char *outputField, nsIRunnable *callback) { return _to Init(parent, commandData, inputField, outputField, callback); } \
  NS_IMETHOD Apply_filter(void) { return _to Apply_filter(); } \
  NS_IMETHOD Open_dialog(void) { return _to Open_dialog(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_CMGUIIDISCRETEGAUSSIANFILTER(_to) \
  NS_IMETHOD Init(nsIDOMWindow *parent, CmguiICommandData *commandData, const char *inputField, const char *outputField, nsIRunnable *callback) { return !_to ? NS_ERROR_NULL_POINTER : _to->Init(parent, commandData, inputField, outputField, callback); } \
  NS_IMETHOD Apply_filter(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Apply_filter(); } \
  NS_IMETHOD Open_dialog(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Open_dialog(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public cmguiIDiscreteGaussianFilter
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_CMGUIIDISCRETEGAUSSIANFILTER

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, cmguiIDiscreteGaussianFilter)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void init (in nsIDOMWindow parent, in CmguiICommandData commandData, in string inputField, in string outputField, in nsIRunnable callback); */
NS_IMETHODIMP _MYCLASS_::Init(nsIDOMWindow *parent, CmguiICommandData *commandData, const char *inputField, const char *outputField, nsIRunnable *callback)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void apply_filter (); */
NS_IMETHODIMP _MYCLASS_::Apply_filter()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void open_dialog (); */
NS_IMETHODIMP _MYCLASS_::Open_dialog()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_DiscreteGaussianFilter_h__ */
