#!/usr/bin/perl -i.bak

sub do_simple_subs
  {
	 s/moz[cC]mgui/zinc/g;
	 s/x-general-plugin/x-zinc-plugin/g;
	 s/\@physiome.org/\@physiomeproject.org/g;
	 s/mozDownloadMonitor/zincDownloadMonitor/g;
	 s/mozIDownloadMonitor/zincIDownloadMonitor/g;
	 s/window.zincDefineMemoryBlock/zincDefineMemoryBlock/g;
	 s/new\s+(\w+)Ready\(\)/$1ReadyFunction/g;


 if (s/cmguiReady:(\s*)function\((\w+)\)/cmguiReady:$1function(zincCommandData)/)
	{
	  $commandData = "zincCommandData";
	}

 s/(min|max)Version\s*=\s*\"0.*\";/$1Version = "0.6.0"/;

 if (m/(\w+)\s*=\s*(\w+)\.window;/)
	{
	  $window_id_variable = $1;
	  $plugin_variable = $2;
	}

 if (s/([\w\.]+)\s*=\s*[\w\.]+\.createCommandData\s*\(\s*\)\s*;/$1 = $commandData/)
	{
	  $commandData = $1;
	}
 if (m/zincRunSafe/)
	{
	  my $found_function = 0;
	  while (!$found_function)
		 {
			if (s/zincRunSafe\(\s*function\(\)\s*{(.+)}\);/$1/)
			  {
				 $found_function = 1;
			  }
			else
			  {
				 if (m/;/)
					{
					  # Give up.
					  $found_function = 1;
					}
				 else
					{
					  $_ .= <>;
					  do_simple_subs();
					}
			  }
		 }
	}


  }

while (<>)
{
  do_simple_subs();


 if (m/zincProxyToMain/)
	{
	  my $found_function = 0;
	  while (!$found_function)
		 {
			if (s/zincProxyToMain\((.+),[\s]+Components\.interfaces\.\w+\)/$1/)
			  {
				 $found_function = 1;
			  }
			else
			  {
				 if (m/;/)
					{
					  # Give up.
					  $found_function = 1;
					}
				 else
					{
					  $_ .= <>;
					  do_simple_subs();
					}
			  }
		 }
	}

 if (m/Ready.prototype/)
	{
	  my $found_function = 0;
	  while (!$found_function)
		 {
			if (s/(\w+)\.prototype\s*=[\s\S]*cmguiReady:\s*function([^}]+)}[\s\S]*};/function $1Function$2\n}/m)
			  {
				 $found_function = 1;
			  }
			elsif (s/(\w+)\.prototype\s*=[\s\S]*sceneViewerReady:\s*function([^}]+)}[\s\S]*};/function $1Function$2\n}/m)
			  {
				 $found_function = 1;
			  }
			else
			  {
				 if (m/};/)
					{
					  # Give up.
					  $found_function = 1;
					}
				 else
					{
					  $_ .= <>;
					  do_simple_subs();
					}
			  }
		 }
	}

 if (m/[pP]reparer/ || m/\@physiomeproject.org\/zinc;1/)
	{
	  my $found_function = 0;
	  while (!$found_function)
		 {
			if (s/Components.classes([\S\s]*)[\w\.]*launchCmgui\((.*)\);/zincInitialise($2);/m)
			  {
				 $found_function = 1;
			  }
			else
			  {
				 if (m/}/)
					{
					  # Give up.
					  $found_function = 1;
					}
				 else
					{
					  $_ .= <>;
					  do_simple_subs();
					}
			  }
		 }
	}

 if (m/zincProxyToMain/)
	{
	  my $found_function = 0;
	  while (!$found_function)
		 {
			if (s/zincProxyToMain\((.+),[\s]+Components\.interfaces\.\w+\)/$1/)
			  {
				 $found_function = 1;
			  }
			else
			  {
				 if (m/;/)
					{
					  # Give up.
					  $found_function = 1;
					}
				 else
					{
					  $_ .= <>;
					  do_simple_subs();
					}
			  }
		 }
	}
 if (m/zincRunSafe/)
	{
	  my $found_function = 0;
	  while (!$found_function)
		 {
			if (s/zincRunSafe\(\s*function\(\)\s*{(.+)}\);/$1/)
			  {
				 $found_function = 1;
			  }
			else
			  {
				 if (m/;/)
					{
					  # Give up.
					  $found_function = 1;
					}
				 else
					{
					  $_ .= <>;
					  do_simple_subs();
					}
			  }
		 }
	}

 if (m/zincDefineMemoryBlock/)
	{
	  my $found_function = 0;
	  while (!$found_function)
		 {
			if (s/zincDefineMemoryBlock\(\w+,([^,]+,[^,]+,[^,)]+\))/zincDefineMemoryBlock($1/g)
			  {
				 $found_function = 1;
			  }
			else
			  {
				 if (m/;/)
					{
					  # Give up.
					  $found_function = 1;
					}
				 else
					{
					  $_ .= <>;
					  do_simple_subs();
					}
			  }
		 }
	}

 if (m/sceneViewer/ || m/createSceneViewer/)
	{
	  my $found_function = 0;
	  while (!$found_function)
		 {
			if (s/([\w\.]+\s*=\s*)?([\w\.]+)\.createSceneViewer\s*\(\s*\w+,/zincCreateSceneViewer($plugin_variable, $2,/)
			  {
				 $found_function = 1;
			  }
			else
			  {
				 if (m/;/)
					{
					  # Give up.
					  $found_function = 1;
					}
				 else
					{
					  $_ .= <>;
					  do_simple_subs();
					}
			  }
		 }
	}

 if (m/\@physiomeproject.org\/zinc\/zincDownload/)
	{
	  my $found_function = 0;
	  while (!$found_function)
		 {
			if (s/^(\s*)var\s+(\w+)\s*=\s*Components.classes[\S\s]*\.onDownloadsCompleted\s*=\s*([\w\s\(\)]+);/$1var $2 = zincCreateDownloadMonitor($commandData, $3);/m)
			  {
				 $found_function = 1;
				 # No longer wrap argument
				 s/new\s+\w+\((\w+)\)/$1/;
			  }
			else
			  {
				 if (m/}/)
					{
					  # Give up.
					  $found_function = 1;
					}
				 else
					{
					  $_ .= <>;
					  do_simple_subs();
					}
			  }
		 }
	}

 if (!m/\/\//)
	{
	  #If not commented already
	  s/([\w\.]+\.setWindowSize\()/\/\/$1/;
	  s/([\w\.]+\.executeCommand.*print)/\/\/$1/;
	}


 print;
}
